
__int64 _ctr_tsc1_;
__int64 _ctr_tsc2_;
__int64 _ctr_overhead_;
__int64 ctr_cycles;
int     _ctr_loopcount_;
int     _ctr_loopcounter_;

__declspec( naked ) void _ctr_code1_()
{
    __asm
    {
        xor eax, eax
        cpuid
        rdtsc
        mov dword ptr [_ctr_tsc1_], eax
        mov dword ptr [_ctr_tsc1_+4], edx
        ret
    }
}

__declspec( naked ) void _ctr_code2_()
{
    __asm
    {
        xor eax, eax
        cpuid
        rdtsc
        mov dword ptr [_ctr_tsc2_], eax
        mov dword ptr [_ctr_tsc2_+4], edx
        ret
    }
}

__declspec( naked ) void _ctr_warmup_()
{
    __asm
    {
        xor eax, eax
        cpuid
        xor eax, eax
        cpuid
        xor eax, eax
        cpuid
        ret
    }
}

#define CTR_BEGIN( n, loop_count, priority_class )            \
    _ctr_overhead_ = 2000000000;                              \
    ctr_cycles = 2000000000;                                  \
    _ctr_loopcount_ = loop_count;                             \
    SetPriorityClass( GetCurrentProcess(), priority_class );  \
    _ctr_warmup_();                                           \
    Sleep(0);                                                 \
    _ctr_loopcounter_ = 0;                                    \
    __asm{ align 16 }                                         \
  R##n:                                                       \
    _ctr_code1_();                                            \
    _ctr_code2_();                                            \
    if( _ctr_tsc2_ - _ctr_tsc1_ < _ctr_overhead_ )            \
        _ctr_overhead_ = _ctr_tsc2_ - _ctr_tsc1_;             \
    if( _ctr_loopcounter_++ < _ctr_loopcount_ )               \
        goto R##n;                                            \
    Sleep(0);                                                 \
    _ctr_loopcounter_ = 0;                                    \
    __asm{ align 16 }                                         \
  L##n:                                                       \
    _ctr_code1_();

#define CTR_END( n )                                          \
    _ctr_code2_();                                            \
    if( _ctr_tsc2_ - _ctr_tsc1_ < ctr_cycles )                \
        ctr_cycles = _ctr_tsc2_ - _ctr_tsc1_;                 \
    if( _ctr_loopcounter_++ < _ctr_loopcount_ )               \
        goto L##n;                                            \
    ctr_cycles-=_ctr_overhead_;                               \
    SetPriorityClass( GetCurrentProcess(), NORMAL_PRIORITY_CLASS );
